test-lib.sh 6.9 KB
Newer Older
1 2 3 4 5 6 7
#!/bin/sh
#
# Copyright (c) 2005 Junio C Hamano
#

# For repeatability, reset the environment to known value.
LANG=C
8
LC_ALL=C
9
PAGER=cat
10
TZ=UTC
11
export LANG LC_ALL PAGER TZ
12 13
EDITOR=:
VISUAL=:
14
unset GIT_EDITOR
15 16 17 18 19
unset AUTHOR_DATE
unset AUTHOR_EMAIL
unset AUTHOR_NAME
unset COMMIT_AUTHOR_EMAIL
unset COMMIT_AUTHOR_NAME
20
unset EMAIL
21 22
unset GIT_ALTERNATE_OBJECT_DIRECTORIES
unset GIT_AUTHOR_DATE
23 24
GIT_AUTHOR_EMAIL=author@example.com
GIT_AUTHOR_NAME='A U Thor'
25
unset GIT_COMMITTER_DATE
26 27
GIT_COMMITTER_EMAIL=committer@example.com
GIT_COMMITTER_NAME='C O Mitter'
28 29
unset GIT_DIFF_OPTS
unset GIT_DIR
30
unset GIT_WORK_TREE
31 32 33 34 35
unset GIT_EXTERNAL_DIFF
unset GIT_INDEX_FILE
unset GIT_OBJECT_DIRECTORY
unset SHA1_FILE_DIRECTORIES
unset SHA1_FILE_DIRECTORY
36 37
GIT_MERGE_VERBOSITY=5
export GIT_MERGE_VERBOSITY
38 39
export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
40
export EDITOR VISUAL
41

42 43 44 45
# Protect ourselves from common misconfiguration to export
# CDPATH into the environment
unset CDPATH

46
case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
47 48 49 50 51 52 53 54
	1|2|true)
		echo "* warning: Some tests will not work if GIT_TRACE" \
			"is set as to trace on STDERR ! *"
		echo "* warning: Please set GIT_TRACE to something" \
			"other than 1, 2 or true ! *"
		;;
esac

55 56 57 58 59 60 61
# Each test should start with something like this, after copyright notices:
#
# test_description='Description of this test...
# This test checks if command xyzzy does the right thing...
# '
# . ./test-lib.sh

62
[ "x$TERM" != "xdumb" ] &&
63
	[ -t 1 ] &&
64 65 66 67
	tput bold >/dev/null 2>&1 &&
	tput setaf 1 >/dev/null 2>&1 &&
	tput sgr0 >/dev/null 2>&1 &&
	color=t
68 69 70 71 72 73 74 75 76

test "${test_description}" != "" ||
error "Test script did not set test_description."

while test "$#" -ne 0
do
	case "$1" in
	-d|--d|--de|--deb|--debu|--debug)
		debug=t; shift ;;
J
Junio C Hamano 已提交
77 78
	-i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
		immediate=t; shift ;;
79 80 81 82 83
	-h|--h|--he|--hel|--help)
		echo "$test_description"
		exit 0 ;;
	-v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
		verbose=t; shift ;;
84 85
	-q|--q|--qu|--qui|--quie|--quiet)
		quiet=t; shift ;;
86 87
	--no-color)
	    color=; shift ;;
88
	--no-python)
J
Junio C Hamano 已提交
89 90
		# noop now...
		shift ;;
91 92 93 94 95
	*)
		break ;;
	esac
done

96 97 98 99 100 101 102
if test -n "$color"; then
	say_color () {
		case "$1" in
			error) tput bold; tput setaf 1;; # bold red
			skip)  tput bold; tput setaf 2;; # bold green
			pass)  tput setaf 2;;            # green
			info)  tput setaf 3;;            # brown
103
			*) test -n "$quiet" && return;;
104 105 106 107 108 109 110
		esac
		shift
		echo "* $*"
		tput sgr0
	}
else
	say_color() {
111
		test -z "$1" && test -n "$quiet" && return
112 113 114 115 116 117 118 119 120 121 122 123 124 125 126
		shift
		echo "* $*"
	}
fi

error () {
	say_color error "error: $*"
	trap - exit
	exit 1
}

say () {
	say_color info "$*"
}

127
exec 5>&1
128 129 130 131 132 133 134 135 136 137
if test "$verbose" = "t"
then
	exec 4>&2 3>&1
else
	exec 4>/dev/null 3>/dev/null
fi

test_failure=0
test_count=0

138 139
trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit

140 141 142
test_tick () {
	if test -z "${test_tick+set}"
	then
J
Junio C Hamano 已提交
143
		test_tick=1112911993
144 145 146
	else
		test_tick=$(($test_tick + 60))
	fi
J
Junio C Hamano 已提交
147 148
	GIT_COMMITTER_DATE="$test_tick -0700"
	GIT_AUTHOR_DATE="$test_tick -0700"
149 150
	export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
}
151

J
Junio C Hamano 已提交
152 153 154 155
# You are not expected to call test_ok_ and test_failure_ directly, use
# the text_expect_* functions instead.

test_ok_ () {
156
	test_count=$(expr "$test_count" + 1)
157
	say_color "" "  ok $test_count: $@"
158 159
}

J
Junio C Hamano 已提交
160
test_failure_ () {
161 162
	test_count=$(expr "$test_count" + 1)
	test_failure=$(expr "$test_failure" + 1);
163
	say_color error "FAIL $test_count: $1"
164 165
	shift
	echo "$@" | sed -e 's/^/	/'
166
	test "$immediate" = "" || { trap - exit; exit 1; }
J
Junio C Hamano 已提交
167 168 169 170
}


test_debug () {
171
	test "$debug" = "" || eval "$1"
172 173
}

174 175 176 177 178 179
test_run_ () {
	eval >&3 2>&4 "$1"
	eval_ret="$?"
	return 0
}

180 181 182 183 184 185 186 187 188 189 190 191 192
test_skip () {
	this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
	this_test="$this_test.$(expr "$test_count" + 1)"
	to_skip=
	for skp in $GIT_SKIP_TESTS
	do
		case "$this_test" in
		$skp)
			to_skip=t
		esac
	done
	case "$to_skip" in
	t)
193
		say_color skip >&3 "skipping test: $@"
194
		test_count=$(expr "$test_count" + 1)
195
		say_color skip "skip $test_count: $1"
196 197 198 199 200 201 202 203
		: true
		;;
	*)
		false
		;;
	esac
}

204
test_expect_failure () {
205
	test "$#" = 2 ||
206
	error "bug in the test script: not 2 parameters to test-expect-failure"
207
	if ! test_skip "$@"
208
	then
209 210 211 212 213 214 215 216
		say >&3 "expecting failure: $2"
		test_run_ "$2"
		if [ "$?" = 0 -a "$eval_ret" != 0 -a "$eval_ret" -lt 129 ]
		then
			test_ok_ "$1"
		else
			test_failure_ "$@"
		fi
217
	fi
218
	echo >&3 ""
219 220 221
}

test_expect_success () {
222
	test "$#" = 2 ||
223
	error "bug in the test script: not 2 parameters to test-expect-success"
224
	if ! test_skip "$@"
225
	then
226 227 228 229 230 231 232 233
		say >&3 "expecting success: $2"
		test_run_ "$2"
		if [ "$?" = 0 -a "$eval_ret" = 0 ]
		then
			test_ok_ "$1"
		else
			test_failure_ "$@"
		fi
234
	fi
235
	echo >&3 ""
236 237
}

238 239 240
test_expect_code () {
	test "$#" = 3 ||
	error "bug in the test script: not 3 parameters to test-expect-code"
241
	if ! test_skip "$@"
242
	then
243 244 245 246 247 248 249 250
		say >&3 "expecting exit code $1: $3"
		test_run_ "$3"
		if [ "$?" = 0 -a "$eval_ret" = "$1" ]
		then
			test_ok_ "$2"
		else
			test_failure_ "$@"
		fi
251
	fi
252
	echo >&3 ""
253 254
}

255 256 257 258 259 260 261 262 263
# Most tests can use the created repository, but some amy need to create more.
# Usage: test_create_repo <directory>
test_create_repo () {
	test "$#" = 1 ||
	error "bug in the test script: not 1 parameter to test-create-repo"
	owd=`pwd`
	repo="$1"
	mkdir "$repo"
	cd "$repo" || error "Cannot setup test environment"
264 265
	"$GIT_EXEC_PATH/git" init --template=$GIT_EXEC_PATH/templates/blt/ >/dev/null 2>&1 ||
	error "cannot run git init -- have you built things yet?"
266 267 268
	mv .git/hooks .git/hooks-disabled
	cd "$owd"
}
J
Junio C Hamano 已提交
269

270
test_done () {
271
	trap - exit
272
	case "$test_failure" in
273
	0)
274 275 276 277 278 279 280 281
		# We could:
		# cd .. && rm -fr trash
		# but that means we forbid any tests that use their own
		# subdirectory from calling test_done without coming back
		# to where they started from.
		# The Makefile provided will clean this test area so
		# we will leave things as they are.

282
		say_color pass "passed all $test_count test(s)"
283 284 285
		exit 0 ;;

	*)
286
		say_color error "failed $test_failure among $test_count test(s)"
287 288 289 290 291 292 293 294
		exit 1 ;;

	esac
}

# Test the binaries we have just built.  The tests are kept in
# t/ subdirectory and are run in trash subdirectory.
PATH=$(pwd)/..:$PATH
J
Johannes Schindelin 已提交
295
GIT_EXEC_PATH=$(pwd)/..
J
Johannes Schindelin 已提交
296
GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
297 298
GIT_CONFIG=.git/config
export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG
299

300 301
GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
export GITPERLLIB
302 303 304
test -d ../templates/blt || {
	error "You haven't built things yet, have you?"
}
305

E
Eric Wong 已提交
306 307 308 309 310 311
if ! test -x ../test-chmtime; then
	echo >&2 'You need to build test-chmtime:'
	echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
	exit 1
fi

312 313 314
# Test repository
test=trash
rm -fr "$test"
315 316
test_create_repo $test
cd "$test"
317 318 319 320 321 322 323 324 325 326 327 328 329 330

this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
for skp in $GIT_SKIP_TESTS
do
	to_skip=
	for skp in $GIT_SKIP_TESTS
	do
		case "$this_test" in
		$skp)
			to_skip=t
		esac
	done
	case "$to_skip" in
	t)
331 332
		say_color skip >&3 "skipping test $this_test altogether"
		say_color skip "skip all tests in $this_test"
333 334 335
		test_done
	esac
done